 /*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : MARCH 2009

 File          : Osc_ADITest_Bosch.c

 Hardware      : Applicable to ADuC7038

 Description   : This routine sets 2 interrupts in sequence -through 2 Timers
				  Both timers are set exactly the same - 0x80 - core clock only
 	FIQ - Timer 1 -  Toggles GPIO_1
	IRQ - Timer 2 -  Toggles GPIO_2


		
*********************************************************************/

#include <ADuC7038.h>

#define PAUSE_SYNC  3
#define NO_SYNC_PULSES 3
#define DIR_MASTER 0 		// master sends request
#define DIR_SLAVE  1 		// slave sends request

unsigned short Slave_Address = 0;
unsigned short Register_Address = 0;
                           /* 500s */

// CLK EN bits in PLL Test
#define HCLK     	0x00        // HVLK bits - 10MHZ - depnds on CD
#define VCO_OUT  	0x01        // PLL / VCO ouput
//#define PHASE_DET	0x02        // phase Detector
#define HP_CLK     	0x03        // High Precision osc 128
#define LP_OSC   	0x04        // 3% Osc 	128
#define HV_OSC   	0x05        // 1% Osc	128
//#define BYPASS_PLL  0x06     	//  Ext Clock
#define LOCK     	0x07        // Lock bit



void My_FIQ_Function(void);
void My_IRQ_Function(void);

void delay(int);

unsigned int  adc_status=0 , loop = 0;
unsigned long fifo_data = 0;
unsigned short InfoBit_bt = 0;
unsigned short BsdTxBuffer[22];
	unsigned int Any_status	= 0;
	int status = 0;

   unsigned long it1=1234, it2=4321;

int main()
{
//	unsigned long it1=1234, it2=4321;

//  	GPCON = 0x00200000;				//Enable (GPIO 5 as ECLK, BIt-20) and all others as ouputs.
  	GPCON = 0x00000000;				//Enable (GPIO 5 as ECLK, BIt-20) and all others as ouputs.
	GPDAT = 0x3F000000;				//Enable P0.1(GPIO_1) / P0.2(GPIO_2) /as an output
 	GPSET = 0x003F0000;				// Set all bits to 1
//	GPCLR = 0x003F0000;				// Set all bits to Zero
//	FIQ = My_FIQ_Function; 	// Initialise Interrupt Routine	 for LIN
//	IRQ = My_IRQ_Function;  // Initialise Interrupt Routine	 for Timer2

//	IRQEN = 0x400;			// Enable HV  IRQ
//	FIQEN = 0x20;			// Generate an FIQ on LIN
//	FIQEN = 0x08;			// Generate an FIQ on T1

// SET 10.24 MEg PLL
 	
	POWKEY0 = 0x01;		 			// Put all peripherals, PLL and Core Asleep
	POWCON	 = 0x179;				// default value is 78	- 20MHz
	POWKEY1 = 0xF4;					// 
	it1 = it1*it2;					// Dummy cycle to ensure correct power down 
    delay(20000);
 
    PLLKEY0 = 0x000000AA;
	PLLCON = 0x00;          // Low power oscillator 			  
//	PLLCON = 0x01;        	// Intern 1% Oszillator  Precision 	  
    PLLKEY1 = 0x00000055;
	it1 = it1*it2;			// Dummy cycle to ensure correct power down

    PLLKEY3 = 0x6B;
//	PLLTST = 0x8000	| HCLK <<6;					// 10.24 MHZ
//	PLLTST = 0x8000	| VCO_OUT <<6;				// 20.48 MHZ
	PLLTST = 0x8000	| HP_CLK <<6;				// 128 KHz
//	PLLTST = 0x8000	| HV_OSC <<6;				// 128 KHz
// 	PLLTST = 0x8000	| LP_OSC <<6;				// 128 KHz	
//	PLLTST = 0x8000	| BYPASS_PLL <<6;			// 		
//	PLLTST = 0x8000	| LOCK <<6;					// bit is one ??
    PLLKEY4 = 0xA9;
	it1 = it1*it2;			// Dummy cycle to ensure correct power down

	Any_status = PLLSTA;	// check Lock
	do 
		{
		Any_status = PLLSTA;
		}
	while ((Any_status & 0x02) != 2);
  
// 	GPSET = 0x00030000;				// Set all bits to 1
//	GPCLR = 0x00030000;				// Set all bits to Zero
//	ADCMDE = 0x11;					// Turns on Low powr Reference
	ADCMDE = 0x03;					// Turns on idle mode
	ADC0CON = 0x8202;				// enables VADC Channell - Gain = 4
	ADC1CON = 0x8200;				// enables VADC Channell

	delay(20000000);


// 	GPSET = 0x003F0000;				// Set all bits to 1
//	ADC0CON = 0x0;					// enables VADC Channell
	ADC1CON = 0x00;				// enables VADC Channell

//  POWKEY0 = 0x01;		 			// Put all peripherals, PLL and Core Asleep
//	POWCON	 = 0x000;				// default value is 78	- 20MHz
//	POWKEY1 = 0xF4;					// 
	it1 = it1*it2;					// Dummy cycle to ensure correct power down 


	while(1)
	{
	}    							// Infinite Loop
}

void My_IRQ_Function() 
{

	FEEMOD = 0x08; 			// Allow Single Write 
	FEEADR = 0x01FC;		//address0x8f000
	FEEDAT = 0x0000;
	FEECON = 0x05; 			// Singl ERASE 	
	status = FEESTA;
	while (FEESTA & 0x04); //CHECK for Fail

 	return ;
}

void My_FIQ_Function() 
{
 	GPSET = 0x020000;				// Set GPIO_2 to 1 - T1
	delay(1000);
	GPCLR = 0x020000;				// Set GPIO_2 to 0
	T1CLRI = 0;													  

	 return;
}

void delay (int length){
	while (length >=0)
    	length--;
}
